Python擴展問題”unable to find vcvarsall.bat“的解決


轉自:http://www.linuxidc.com/Linux/2011-08/39722.htm


解決方法是》比較hack的方法是直接修改C:/Python32/Lib/distutils/msvc9compiler.py

def find_vcvarsall(version):
    return r'C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\vcvarsall.bat'


============== 以下為轉載內容 ============

在用C給python3.寫擴展時遇到如下問題:

寫好*module.c和setup.py文件后執行

python setup.py build

報unable to find vcvarsall.bat

我機器上有vs2005和vc6,但是還是報錯。

搜索很多資料:

網上提供解決辦法如下:

下載mingw環境,添加環境變量

使用

python setup.py build –compiler=mingw32

這個辦法感覺只是繞過了這個問題,並不是真正解決問題,而且我系統中python是用vs編譯的,擴展模塊卻用mingw-gcc編譯,感覺可能有問題。

但網上對此就缺少詳細的說明

經過對C:/Python32/Lib/distutils目錄下.py文件的仔細翻閱,發現“unable to find vcvarsall.bat”這句話出在msvc9compiler.py中

再研究這個文件發現問題所在了:

它是在注冊表中尋找到vs的目錄,再去在vs目錄下找vcvarsall.bat。

但是問題就出在python32里面默認是vc9.0也就是vs2008所以它在注冊表里面找不到鍵值返回None

productdir = Reg.get_value(r"%s/Setup/VC" % vsbase,

"productdir")

vsbase值為:Software/Microsoft/VisualStudio/9.0

具體修改代碼如下:

msvc9compiler.py中

def find_vcvarsall(version) 用於查找vcvarsall.bat version就是版本號,實際上是9.0

vc_env = query_vcvarsall(VERSION, plat_spec)

VERSION = get_build_version() 因為python32自己是由vc9.0構建的所以VERSION是9.0

修改MSVCCompiler函數:

vc_env = query_vcvarsall(VERSION, plat_spec)

為:

vc_env = query_vcvarsall(8.0, plat_spec)

不過還有這句話:

if VERSION < 8.0:

raise DistutilsPlatformError("VC %0.1f is not supported by this module" % VERSION)

看來,python3.2中的distutils只支持vc8.0以上,即vs2005以上的編譯器。


注意!

本站转载的文章为个人学习借鉴使用,本站对版权不负任何法律责任。如果侵犯了您的隐私权益,请联系我们删除。



 
粤ICP备14056181号  © 2014-2021 ITdaan.com